addhook("always","_always")
addhook("spawn","_spawn")
addhook("drop","_drop")
addhook("join","_join")
addhook("team","_team")
addhook("die","_die")

parse("mp_deathdrop 4")
parse("gore 0")
parse("drawradar 0")
parse("markplayer 0")
parse("sv_lan 1")
parse("sv_maxplayers 2")
parse("mapshadows 0")


function _die(id)
	if id==1 then
		freeimage(img)
		respawn()
	end
end

function _team(id)
	if id==1 then
		if canTeam==nil then
			return 1
		end
		canTeam=nil
	end
end

function respawn()
	local spawnx,spawny=randomentity(1)
	while entity(spawnx,spawny,"state")==true do
		spawnx,spawny=randomentity(1)
	end
	parse("spawnplayer 1 ".. (spawnx*32+16).." "..(spawny*32+16))
	parse("setmoney 1 0")
end

function _join(id)
	if id==1 then
		canTeam=true
		parse("maket 1")
		respawn()
	end
end

function _drop()
	return 1
end

function _spawn()
	dx=player(1,"x")
	dy=player(1,"y")
	img=image("gfx/erika_furudo/stand.png",0,0,201)
	timer(0,"proper_wpns")
end

function proper_wpns()
	parse("equip 1 41")
	parse("setarmor 1 206")
	parse("setweapon 1 41")
	for _,wpn in pairs(playerweapons(1)) do
		if wpn~=41 then
			parse("strip 1 "..wpn)
		end
	end
end

gravity=0
frame=1
rate=5
count=rate
rate_idle=10
idle=rate_idle
dir="right"

function inAir()
	for xloop=x-16,x+16,16 do
		if tile(math.floor((xloop)/32),math.floor((y+50)/32),"walkable")==false then
			return true
		end
	end
	return false
end

function _always()
	if player(1,"health")==0 then
		return
	end
	gravity=gravity+0.5
	x=player(1,"x")
	y=player(1,"y")+gravity
	if inAir()==false then
		freeimage(img)
		img=image("gfx/erika_furudo/jump.png",0,0,201)
		if dir=="left" then
			imagescale(img,-1,1)
		end
	end
	if x>dx then
		parse("speedmod 1 20")
		dir="right"
		if inAir() then
		count=count-1
			if count<=0 then
				frame=frame+1
				if frame>=9 then
					frame=1
				end
				freeimage(img)
				img=image("gfx/erika_furudo/"..frame..".png",0,0,201)
				count=rate
				idle=rate_idle
			end
		end
	elseif x<dx then
		parse("speedmod 1 8")
		dir="left"
		if inAir() then
		count=count-1
			if count<=0 then
				frame=frame+1
				if frame>=9 then
					frame=1
				end
				freeimage(img)
				img=image("gfx/erika_furudo/"..frame..".png",0,0,201)
				imagescale(img,-1,1)
				count=rate
				idle=rate_idle
			end
		end
	end
	if inAir() then
	idle=idle-1
		if idle<=0 then
			frame=1
			freeimage(img)
			img=image("gfx/erika_furudo/stand.png",0,0,201)
			if dir=="left" then
				imagescale(img,-1,1)
			end
		end
	end
	rx=x
	ry=y
	for xloop=x-16,x+16,16 do
		if canMove(math.floor((xloop)/32),math.floor((y+48)/32))==false then
			if y>dy then
				ry=dy
				y=y-gravity
				gravity=0
				canJump=true
				break
			end
		end
	end
	for xloop=x-16,x+16,16 do
		if canMove(math.floor((xloop)/32),math.floor((y-48)/32))==false then
			if y<dy then
				ry=dy
				gravity=5
				y=y-gravity
				break
			end
		end
	end
	for yloop=y-48,y+48,24 do
		if canMove(math.floor((x-22)/32),math.floor(yloop/32))==false then
			if x<dx then
				rx=dx
				break
			end
		end
	end
	for yloop=y-48,y+48,24 do
		if canMove(math.floor((x+22)/32),math.floor(yloop/32))==false then
			if x>dx then
				rx=dx
				break
			end
		end
	end
	if canJump and y<dy then
		gravity=-7
		canJump=false
	end
	parse("setpos 1 "..rx.." "..ry)
	dx=player(1,"x")
	dy=player(1,"y")
end

function canMove(x,y)
	if tile(x,y,"wall") then
		return false
	end
	if x<0 or x>map("xsize") or y<0 or y>map("ysize") then
		return false
	end
	return true
end